<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Farmwise Node  Mqtt Websocket</title>
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="js/mqttws31.js" type="text/javascript"></script>
    <script src="js/jquery.min.js" type="text/javascript"></script>
    <script src="js/config.js" type="text/javascript"></script>
  </head>
  <body>
    <h1>Farmwise Node  Mqtt Websocket</h1>
     <div id="container"></div>
     <script type="text/javascript">
      var chart;
      var mqtt;
      var topic = "juliesundar/codettes/01"; // Specify the topic here
      var responseObject = {}; // define responseObject variable
      var reconnectTimeout = 2000;

 
    function MQTTconnect() {
	if (typeof path == "undefined") {
		path = '/mqtt';
	}
	mqtt = new Paho.MQTT.Client(
			host,
			port,
			path,
			"web_" + parseInt(Math.random() * 100, 10)
	);
        var options = {
            timeout: 3,
            useSSL: useTLS,
            cleanSession: cleansession,
            onSuccess: onConnect,
            onFailure: function (message) {
                $('#status').val("Connection failed: " + message.errorMessage + "Retrying");
                setTimeout(MQTTconnect, reconnectTimeout);
            }
        };

        mqtt.onConnectionLost = onConnectionLost;
        mqtt.onMessageArrived = onMessageArrived;

        if (username != null) {
            options.userName = username;
            options.password = password;
        }
        console.log("Host="+ host + ", port=" + port + ", path=" + path + " TLS = " + useTLS + " username=" + username + " password=" + password);
        mqtt.connect(options);
    }

function onConnect() {
    $('#status').val('Connected to ' + host + ':' + port + path);
    // Connection succeeded; subscribe to our topic
    mqtt.subscribe(topic, {qos: 0});
    $('#topic2').val(topic);



    // Set up chart
    chart = Highcharts.chart('container', {
      chart: {
        type: 'line',
        turboThreshold: 10000 // set to 0 to disable thresholding and display all points
      },
      title: {
        text: 'Sensor Data'
      },
      xAxis: {
        type: 'datetime',
        title: {
          text: 'Timestamp'
        }
      },
      yAxis: [{
        title: {
          text: 'Temperature'
        }
      }, {
        title: {
          text: 'Humidity'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Soil Moisture'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Salt'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Light'
        },
        opposite: true // display on opposite side of chart
      }, {
        title: {
          text: 'Battery'
        },
        opposite: true // display on opposite side of chart
      }],
      series: [{
        name: 'Temperature',
        data: [],
        yAxis: 0 // use the first yAxis (index 0) for this series
      }, {
        name: 'Humidity',
        data: [],
        yAxis: 1 // use the second yAxis (index 1) for this series
      }, {
        name: 'Soil Moisture',
        data: [],
        yAxis: 2 // use the third yAxis (index 2) for this series
      }, {
        name: 'Salt',
        data: [],
        yAxis: 3 // use the fourth yAxis (index 3) for this series
      }, {
        name: 'Light',
        data: [],
        yAxis: 4 // use the fifth yAxis (index 4) for this series
      }, {
        name: 'Battery',
        data: [],
        yAxis: 5 // use the sixth yAxis (index 5) for this series
      }]
    });


}

  function onConnectionLost(responseObject) {
  setTimeout(MQTTconnect, reconnectTimeout);
  $('#status').val("Connection lost: " + responseObject.errorMessage + ". Reconnecting");
}

function onMessageArrived(message) {
  var topic = message.destinationName;
  var payload = message.payloadString;
  $('#ws').prepend('<li>' + topic + ' = ' + payload + '</li>');
  console.log("Message received: " + payload);

  // Parse message data
  var data = JSON.parse(payload);
  var timestamp = new Date().getTime();
  var temp = parseFloat(data.temp);
  var humid = parseFloat(data.humid);
  var soil = parseFloat(data.soil);
  var salt = parseFloat(data.salt);
  var light = parseFloat(data.light);
  var batt = parseFloat(data.batt);
  
  chart.series[0].addPoint([timestamp, temp]);
  chart.series[1].addPoint([timestamp, humid]);
  chart.series[2].addPoint([timestamp, soil]);
  chart.series[3].addPoint([timestamp, salt]);
  chart.series[4].addPoint([timestamp, light]);
  chart.series[5].addPoint([timestamp, batt]);
}

$(document).ready(function() {
  MQTTconnect();
});
    </script>
     <div>
        <div>Subscribed to <input type='text' id='topic2' disabled />
        Status: <input type='text' id='status' size="80" disabled /></div>
        <ul id='ws' style="font-family: 'Courier New', Courier, monospace;"></ul>
    </div>
  </body>
</html>
